Index: src/Shapes/Shape_impl.hpp
===================================================================
--- src/Shapes/Shape_impl.hpp	(revision 22425a9c1deaa6c8fe8844c40fe08d87a46164b9)
+++ src/Shapes/Shape_impl.hpp	(revision 510f8114d39633be815ec5bf2eb8bf42f5b30f6a)
@@ -15,9 +15,14 @@
 
 
+#include <limits>
 #include <vector>
+
+#include "CodePatterns/Assert.hpp"
 
 #include "Shapes/Shape.hpp"
 #include "Shapes/ShapeExceptions.hpp"
+#include "Shapes/ShapeType.hpp"
 #include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/LinePoint.hpp"
 #include "LinearAlgebra/LineSegment.hpp"
 #include "LinearAlgebra/LineSegmentSet.hpp"
@@ -29,30 +34,55 @@
   Shape_impl(){};
   virtual ~Shape_impl(){};
-  virtual bool isInside(const Vector &point)=0;
-  virtual bool isOnSurface(const Vector &point)=0;
-  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException)=0;
-  virtual LineSegmentSet getLineIntersections(const Line&)=0;
-  virtual std::string toString()=0;
+  virtual bool isInside(const Vector &point) const=0;
+  virtual bool isOnSurface(const Vector &point) const=0;
+  virtual Vector getNormal(const Vector &point) const throw(NotOnSurfaceException)=0;
+  virtual Vector getCenter() const=0;
+  virtual double getRadius() const=0;
+  virtual double getVolume() const=0;
+  virtual double getSurfaceArea() const=0;
+  virtual LineSegmentSet getLineIntersections(const Line&) const=0;
+  virtual std::string toString() const =0;
+  virtual enum ShapeType getType() const =0;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const=0;
+  virtual   std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const=0;
 };
 
 class Everywhere_impl : public Shape_impl {
 public:
-  virtual bool isInside(const Vector &point){
+  virtual bool isInside(const Vector &point) const{
     return true;
   }
-  virtual bool isOnSurface(const Vector &point){
+  virtual bool isOnSurface(const Vector &point) const{
     return false;
   }
-  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException){
+  virtual Vector getNormal(const Vector &point) const throw(NotOnSurfaceException){
     throw NotOnSurfaceException() << ShapeVector(&point);
   }
-  virtual LineSegmentSet getLineIntersections(const Line &line){
+  virtual Vector getCenter() const {
+    return Vector(0.,0.,0.);
+  }
+  virtual double getRadius() const {
+    return std::numeric_limits<double>::infinity();
+  }
+  virtual double getVolume() const
+  {
+  	// TODO
+  	return 0.;
+  }
+  virtual double getSurfaceArea() const
+  {
+  	// TODO
+  	return 0.;
+  }
+  virtual LineSegmentSet getLineIntersections(const Line &line) const{
     LineSegmentSet res(line);
     res.insert(LineSegment(line.negEndpoint(),line.posEndpoint()));
     return res;
   }
-  virtual std::string toString(){
+  virtual std::string toString() const{
     return "Everywhere()";
+  }
+  virtual enum ShapeType getType() const {
+  	return EverywhereType;
   }
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const {
@@ -60,21 +90,43 @@
     return PointsOnSurface;
   }
+  std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const {
+  	ASSERT(0,
+  			"Everywhere_impl::getHomogeneousPointsInVolume() - not implemented.");
+  	return std::vector<Vector>();
+  }
 };
 
 class Nowhere_impl : public Shape_impl {
-  virtual bool isInside(const Vector &point){
+  virtual bool isInside(const Vector &point) const{
     return false;
   }
-  virtual bool isOnSurface(const Vector &point){
+  virtual bool isOnSurface(const Vector &point) const{
     return false;
   }
-  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException){
+  virtual Vector getNormal(const Vector &point) const throw(NotOnSurfaceException){
     throw NotOnSurfaceException() << ShapeVector(&point);
   }
-  virtual LineSegmentSet getLineIntersections(const Line &line){
+  virtual Vector getCenter() const {
+    return Vector(0.,0.,0.);
+  }
+  virtual double getRadius() const {
+    return 0.;
+  }
+  virtual double getVolume() const
+  {
+  	return 0.;
+  }
+  virtual double getSurfaceArea() const
+  {
+  	return 0.;
+  }
+  virtual LineSegmentSet getLineIntersections(const Line &line) const{
     return LineSegmentSet(line);
   }
-  virtual std::string toString(){
+  virtual std::string toString() const{
     return "Nowhere()";
+  }
+  virtual enum ShapeType getType() const {
+  	return NowhereType;
   }
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const {
@@ -82,4 +134,7 @@
     return PointsOnSurface;
   }
+  std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const {
+  	return std::vector<Vector>();
+  }
 };
 
@@ -88,10 +143,16 @@
   AndShape_impl(const Shape::impl_ptr&, const Shape::impl_ptr&);
   virtual ~AndShape_impl();
-  virtual bool isInside(const Vector &point);
-  virtual bool isOnSurface(const Vector &point);
-  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException);
-  virtual LineSegmentSet getLineIntersections(const Line&);
-  virtual std::string toString();
+  virtual bool isInside(const Vector &point) const;
+  virtual bool isOnSurface(const Vector &point) const;
+  virtual Vector getNormal(const Vector &point) const throw(NotOnSurfaceException);
+  virtual Vector getCenter() const;
+  virtual double getRadius() const;
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual LineSegmentSet getLineIntersections(const Line&) const;
+  virtual std::string toString() const;
+  virtual enum ShapeType getType() const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 private:
   Shape::impl_ptr lhs;
@@ -103,10 +164,16 @@
   OrShape_impl(const Shape::impl_ptr&, const Shape::impl_ptr&);
   virtual ~OrShape_impl();
-  virtual bool isInside(const Vector &point);
-  virtual bool isOnSurface(const Vector &point);
-  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException);
-  virtual LineSegmentSet getLineIntersections(const Line&);
-  virtual std::string toString();
+  virtual bool isInside(const Vector &point) const;
+  virtual bool isOnSurface(const Vector &point) const;
+  virtual Vector getNormal(const Vector &point) const throw(NotOnSurfaceException);
+  virtual Vector getCenter() const;
+  virtual double getRadius() const;
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual LineSegmentSet getLineIntersections(const Line&) const;
+  virtual std::string toString() const;
+  virtual enum ShapeType getType() const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 private:
   Shape::impl_ptr lhs;
@@ -118,10 +185,16 @@
   NotShape_impl(const Shape::impl_ptr&);
   virtual ~NotShape_impl();
-  virtual bool isInside(const Vector &point);
-  virtual bool isOnSurface(const Vector &point);
-  virtual Vector getNormal(const Vector &point) throw(NotOnSurfaceException);
-  virtual LineSegmentSet getLineIntersections(const Line&);
-  virtual std::string toString();
+  virtual bool isInside(const Vector &point) const;
+  virtual bool isOnSurface(const Vector &point) const;
+  virtual Vector getNormal(const Vector &point) const throw(NotOnSurfaceException);
+  virtual Vector getCenter() const;
+  virtual double getRadius() const;
+  virtual double getVolume() const;
+  virtual double getSurfaceArea() const;
+  virtual LineSegmentSet getLineIntersections(const Line&) const;
+  virtual std::string toString() const;
+  virtual enum ShapeType getType() const;
   virtual std::vector<Vector> getHomogeneousPointsOnSurface(const size_t N) const;
+  virtual std::vector<Vector> getHomogeneousPointsInVolume(const size_t N) const;
 private:
   Shape::impl_ptr arg;
